import { __decorate, __metadata } from 'tslib';
import { Prop, Component } from 'vue-property-decorator';
import BaseComponent from '../../BaseComponent.js';
import _mergeJSXProps from '@vue/babel-helper-vue-jsx-merge-props';
import { BaseButton } from '../BaseButton.js';
import { getStyles } from './ActionButton.styles.js';

let ActionButton = class ActionButton extends BaseComponent {
  get internalStyles() {
    const {
      theme,
      styles
    } = this;
    return getStyles(theme, styles);
  }

  render() {
    const h = arguments[0];
    const props = Object.assign(Object.assign({}, this.$props), {
      variantClassName: 'ms-Button--action ms-Button--command',
      styles: this.internalStyles
    });
    return h(BaseButton, _mergeJSXProps([{}, {
      props,
      attrs: this.$attrs,
      on: this.$listeners,
      scopedSlots: this.$scopedSlots
    }]));
  }

};

__decorate([Prop({
  type: String,
  default: ''
}), __metadata("design:type", String)], ActionButton.prototype, "href", void 0);

__decorate([Prop({
  type: Boolean,
  default: false
}), __metadata("design:type", Boolean)], ActionButton.prototype, "disabled", void 0);

__decorate([Prop({
  type: Object,
  default: null
}), __metadata("design:type", Object)], ActionButton.prototype, "iconProps", void 0);

ActionButton = __decorate([Component], ActionButton);

export { ActionButton };
