import { __decorate, __metadata } from 'tslib';
import { Prop, Component } from 'vue-property-decorator';
import BaseComponent from '../../BaseComponent.js';
import { BaseButton } from '../BaseButton.js';
import { getStyles } from './DefaultButton.styles.js';

let DefaultButton = class DefaultButton extends BaseComponent {
  get internalStyles() {
    const {
      primary = false,
      theme
    } = this;
    return getStyles(theme, this.styles, primary);
  }

  render() {
    const h = arguments[0];
    const {
      primary,
      internalStyles
    } = this;
    const props = Object.assign(Object.assign({}, this.$props), {
      variantClassName: primary ? 'ms-Button--primary' : 'ms-Button--default',
      styles: internalStyles
    });
    return h(BaseButton, {
      "props": { ...props
      },
      "attrs": { ...this.$attrs
      }
    }, [this.$slots.default]);
  }

};

__decorate([Prop({
  type: String,
  default: ''
}), __metadata("design:type", String)], DefaultButton.prototype, "text", void 0);

__decorate([Prop({
  type: Boolean,
  default: false
}), __metadata("design:type", Boolean)], DefaultButton.prototype, "primary", void 0);

__decorate([Prop({
  type: Boolean,
  default: false
}), __metadata("design:type", Boolean)], DefaultButton.prototype, "disabled", void 0);

DefaultButton = __decorate([Component], DefaultButton);

export { DefaultButton };
