import { __decorate } from 'tslib';
import { Component } from 'vue-property-decorator';
import BaseComponent from '../../BaseComponent.js';
import { BaseButton } from '../BaseButton.js';
import { DefaultButton } from '../DefaultButton/DefaultButton.js';
import { getStyles } from './MessageBarButton.styles.js';

let MessageBarButton = class MessageBarButton extends BaseComponent {
  get internalStyles() {
    return getStyles(this.theme, this.styles);
  }

  render() {
    const h = arguments[0];
    const {
      internalStyles
    } = this;
    const props = {
      variantClassName: 'ms-Button--icon',
      styles: internalStyles
    };
    return h(BaseButton, {
      "props": { ...props
      },
      "attrs": { ...this.$attrs
      }
    }, [this.$slots.default]);
  }

};
MessageBarButton = __decorate([Component({
  components: {
    DefaultButton
  }
})], MessageBarButton);

export { MessageBarButton };
