import { __rest, __decorate, __metadata } from 'tslib';
import { Prop, Component } from 'vue-property-decorator';
import StatelessComponent from '../StatelessComponent.js';
import { Layer } from '../Layer/Layer.js';
import { DirectionalHint } from '../../common/DirectionalHint.js';
import { CalloutContent } from './CalloutContent.js';

let Callout = class Callout extends StatelessComponent {
  render(h, context) {
    if (!(context.props.target instanceof Node)) return;

    const _a = context.props,
          {
      layerProps
    } = _a,
          rest = __rest(_a, ["layerProps"]);

    const content = h(CalloutContent, Object.assign(Object.assign({}, context.data), {
      props: Object.assign(Object.assign({}, rest), context.data.attrs)
    }), context.children);
    return context.props.doNotLayer ? content : h(Layer, Object.assign(Object.assign({}, context.data), {
      props: Object.assign({}, layerProps)
    }), [content]);
  }

};

__decorate([Prop({
  type: HTMLElement,
  required: true
}), __metadata("design:type", Object)], Callout.prototype, "target", void 0);

__decorate([Prop({
  type: Boolean,
  default: false
}), __metadata("design:type", Boolean)], Callout.prototype, "doNotLayer", void 0);

__decorate([Prop({
  type: Number,
  default: DirectionalHint.bottomAutoEdge
}), __metadata("design:type", Boolean)], Callout.prototype, "directionalHint", void 0);

Callout = __decorate([Component], Callout);

export { Callout };
