import { __decorate, __metadata } from 'tslib';
import { Prop, Component } from 'vue-property-decorator';
import { classNamesFunction } from '@uifabric-vue/utilities';
import BaseComponent from '../BaseComponent.js';
import _mergeJSXProps from '@vue/babel-helper-vue-jsx-merge-props';
import Icon from '../Icon/Icon.js';

const getClassNames = classNamesFunction();
let ContextualMenuItem = class ContextualMenuItem extends BaseComponent {
  constructor() {
    super(...arguments);

    this.openSubMenu = () => {
      //   const submenuTarget = getSubmenuTarget()
      //   // if (hasSubmenu(item) && openSubMenu && submenuTarget) {
      //   //   openSubMenu(item, submenuTarget)
      //   // }
      // }
    };
  }

  get classNames() {
    return getClassNames(this.styles, {
      theme: this.theme
    });
  }

  render() {
    const h = arguments[0];
    const {
      item,
      classNames
    } = this;
    console.log(classNames);
    return h("button", {
      "class": classNames.root
    }, [h("div", {
      "class": item.split ? classNames.linkContentMenu : classNames.linkContent
    }, [this.renderCheckMarkIcon(this), this.renderItemIcon(this), this.renderItemName(this), this.renderSecondaryText(this), this.renderSubMenuIcon(this)])]);
  }

  dismissSubMenu() {// const { item, dismissSubMenu } = this
    // if (hasSubmenu(item) && dismissSubMenu) {
    //   dismissSubMenu()
    // }
  }

  dismissMenu(dismissAll) {// const { dismissMenu } = this.props
    // if (dismissMenu) {
    //   dismissMenu(undefined /* ev */, dismissAll)
    // }
  }

  renderItemIcon(props) {
    const h = this.$createElement;
    const {
      item,
      hasIcons,
      classNames
    } = props;
    const {
      iconProps
    } = item;

    if (!hasIcons) {
      return null;
    }

    if (item.onRenderIcon) {
      return item.onRenderIcon(props);
    }

    return h(Icon, _mergeJSXProps([{}, iconProps, {
      "class": classNames.icon
    }]));
  }

  renderCheckMarkIcon({
    onCheckmarkClick,
    item,
    classNames
  }) {
    const h = this.$createElement;
    const isItemChecked = false; // getIsChecked(item)

    if (onCheckmarkClick) {
      // Ensures that the item is passed as the first argument to the checkmark click callback.
      const onClick = e => onCheckmarkClick(item, e);

      return h(Icon, {
        "attrs": {
          "icon-name": item.canCheck !== false && isItemChecked ? 'CheckMark' : '',
          "class-name": classNames.checkmarkIcon
        },
        "on": {
          "click": onClick
        }
      });
    }

    return null;
  }

  renderItemName({
    item,
    classNames
  }) {
    const h = this.$createElement;

    // tslint:disable:deprecation
    if (item.text || item.name) {
      return h("span", {
        "class": classNames.label
      }, [item.text || item.name]);
    } // tslint:enable:deprecation


    return null;
  }

  renderSecondaryText({
    item,
    classNames
  }) {
    const h = this.$createElement;

    if (item.secondaryText) {
      return h("span", {
        "class": classNames.secondaryText
      }, [item.secondaryText]);
    }

    return null;
  }

  renderSubMenuIcon({
    item,
    classNames,
    theme
  }) {
    // if (hasSubmenu(item)) {
    //   return <Icon iconName={getRTL(theme) ? 'ChevronLeft' : 'ChevronRight'} {...item.submenuIconProps} class={classNames.subMenuIcon} />
    // }
    return null;
  }

};

__decorate([Prop({
  type: Object,
  default: () => {}
}), __metadata("design:type", Object)], ContextualMenuItem.prototype, "item", void 0);

ContextualMenuItem = __decorate([Component({
  components: {}
})], ContextualMenuItem);
var ContextualMenuItemBase = ContextualMenuItem;

export default ContextualMenuItemBase;
