import { memoizeFunction } from '@uifabric-vue/utilities';
import { concatStyleSets } from '@uifabric/merge-styles';
import { getStyles as getStyles$1 } from '../../Button/BaseButton.styles.js';

const getStyles = memoizeFunction((theme, className, customStyles) => {
  const baseButtonStyles = getStyles$1(theme);
  const customButtonStyles = concatStyleSets(baseButtonStyles, customStyles);
  return Object.assign(Object.assign({}, customButtonStyles), {
    root: [baseButtonStyles.root, className, theme.fonts.medium, customStyles && customStyles.root]
  });
});

export { getStyles };
