import { __decorate, __metadata } from 'tslib';
import { Prop, Component } from 'vue-property-decorator';
import { classNamesFunction } from '@uifabric-vue/utilities';
import StatelessComponent from '../StatelessComponent.js';
import _mergeJSXProps from '@vue/babel-helper-vue-jsx-merge-props';

const getClassNames = classNamesFunction({
  disableCaching: true
});
let LabelBase = class LabelBase extends StatelessComponent {
  render(h, context) {
    const {
      theme,
      className,
      disabled,
      required
    } = context.props;
    const classNames = getClassNames(context.props.styles, {
      className,
      disabled,
      required,
      theme: theme
    });
    return h("label", _mergeJSXProps([{
      "class": classNames.root
    }, context.data]), [context.children]);
  }

};

__decorate([Prop({
  type: Boolean,
  default: false
}), __metadata("design:type", Boolean)], LabelBase.prototype, "disabled", void 0);

__decorate([Prop({
  type: Boolean,
  default: false
}), __metadata("design:type", Boolean)], LabelBase.prototype, "required", void 0);

LabelBase = __decorate([Component], LabelBase);

export { LabelBase };
