import { __decorate, __metadata } from 'tslib';
import { Prop, Component } from 'vue-property-decorator';
import { classNamesFunction } from '@uifabric-vue/utilities';
import BaseComponent from '../BaseComponent.js';

const getClassNames = classNamesFunction();
let OverflowSetBase = class OverflowSetBase extends BaseComponent {
  get classNames() {
    const {
      styles,
      className,
      vertical
    } = this;
    return getClassNames(styles, {
      className,
      vertical
    });
  }

  render() {
    const h = arguments[0];
    const {
      classNames,
      items,
      overflowItems
    } = this;
    return h("div", {
      "class": classNames.root
    }, [items.map((item, index) => h("div", {
      "key": index,
      "class": classNames.item
    }, [this.$scopedSlots.item && this.$scopedSlots.item({
      item
    })])), overflowItems && overflowItems.length > 0 && h("div", {
      "class": classNames.overflowButton
    }, [this.$scopedSlots.overflow && this.$scopedSlots.overflow({
      items: overflowItems
    })])]);
  }

};

__decorate([Prop({
  type: Array,
  default: () => []
}), __metadata("design:type", Array)], OverflowSetBase.prototype, "items", void 0);

__decorate([Prop({
  type: Array,
  default: () => []
}), __metadata("design:type", Array)], OverflowSetBase.prototype, "overflowItems", void 0);

__decorate([Prop({
  type: Boolean,
  default: false
}), __metadata("design:type", Boolean)], OverflowSetBase.prototype, "vertical", void 0);

OverflowSetBase = __decorate([Component({
  components: {}
})], OverflowSetBase);

export { OverflowSetBase };
