import { __decorate, __metadata } from 'tslib';
import { Prop, Component } from 'vue-property-decorator';
import { classNamesFunction } from '@uifabric-vue/utilities';
import StatelessComponent from '../../StatelessComponent.js';

const getClassNames = classNamesFunction();
let ShimmerLineBase = class ShimmerLineBase extends StatelessComponent {
  render(h, ctx) {
    const {
      height,
      styles,
      width = '100%',
      borderStyle,
      theme
    } = ctx.props;
    const classNames = getClassNames(styles, {
      theme: theme,
      height,
      borderStyle
    });
    return h("div", {
      "style": {
        width: width,
        minWidth: typeof width === 'number' ? `${width}px` : 'auto'
      },
      "class": classNames.root
    }, [h("svg", {
      "attrs": {
        "width": "2",
        "height": "2"
      },
      "class": classNames.topLeftCorner
    }, [h("path", {
      "attrs": {
        "d": "M0 2 A 2 2, 0, 0, 1, 2 0 L 0 0 Z"
      }
    })]), h("svg", {
      "attrs": {
        "width": "2",
        "height": "2"
      },
      "class": classNames.topRightCorner
    }, [h("path", {
      "attrs": {
        "d": "M0 0 A 2 2, 0, 0, 1, 2 2 L 2 0 Z"
      }
    })]), h("svg", {
      "attrs": {
        "width": "2",
        "height": "2"
      },
      "class": classNames.bottomRightCorner
    }, [h("path", {
      "attrs": {
        "d": "M2 0 A 2 2, 0, 0, 1, 0 2 L 2 2 Z"
      }
    })]), h("svg", {
      "attrs": {
        "width": "2",
        "height": "2"
      },
      "class": classNames.bottomLeftCorner
    }, [h("path", {
      "attrs": {
        "d": "M2 2 A 2 2, 0, 0, 1, 0 0 L 0 2 Z"
      }
    })])]);
  }

};

__decorate([Prop({
  type: Number,
  default: 0
}), __metadata("design:type", Number)], ShimmerLineBase.prototype, "height", void 0);

ShimmerLineBase = __decorate([Component], ShimmerLineBase);
var ShimmerLineBase$1 = ShimmerLineBase;

export default ShimmerLineBase$1;
