import { __decorate, __metadata } from 'tslib';
import { Prop, Component } from 'vue-property-decorator';
import { classNamesFunction } from '@uifabric-vue/utilities';
import StatelessComponent from '../StatelessComponent.js';
import _mergeJSXProps from '@vue/babel-helper-vue-jsx-merge-props';

const getClassNames = classNamesFunction();
let Text = class Text extends StatelessComponent {
  render(h, context) {
    const {
      theme,
      styles,
      block,
      nowrap,
      variant
    } = context.props;
    const classNames = getClassNames(styles, {
      theme,
      block,
      nowrap,
      variant
    });
    return h("span", _mergeJSXProps([{}, context.data, {
      "class": classNames.root
    }]), [context.children]);
  }

};

__decorate([Prop({
  type: Boolean,
  default: false
}), __metadata("design:type", Boolean)], Text.prototype, "nowrap", void 0);

__decorate([Prop({
  type: Boolean,
  default: false
}), __metadata("design:type", Boolean)], Text.prototype, "block", void 0);

__decorate([Prop({
  type: String,
  default: 'medium'
}), __metadata("design:type", String)], Text.prototype, "variant", void 0);

Text = __decorate([Component], Text);
var TextView = Text;

export default TextView;
