import { __rest } from 'tslib';
import { Customizations } from '@uifabric-vue/utilities';
import { concatStyleSetsWithProps } from '@uifabric/merge-styles';
import Vue from 'vue';

const DefaultFields = ['theme', 'styles'];
function styled(Component, baseStyles, getProps, customizable, pure) {
  customizable = customizable || {
    scope: '',
    fields: undefined
  };
  const {
    scope,
    fields = DefaultFields
  } = customizable;

  let _styles;

  const styledComponent = Vue.extend({
    name: `Styled${Component.displayName || Component.name}`,
    // @ts-ignore
    functional: true,

    render(h, context) {
      const settings = Customizations.getSettings(fields, scope);

      const {
        styles: customizedStyles,
        dir
      } = settings,
            rest = __rest(settings, ["styles", "dir"]);

      const additionalProps = getProps ? getProps(this) : undefined;

      if (!_styles || customizedStyles !== _styles.__cachedInputs__[1] || !!context.props.styles) {
        _styles = styleProps => concatStyleSetsWithProps(styleProps, baseStyles, context.props.styles);

        _styles.__cachedInputs__ = [baseStyles, context.props.styles];
      }

      return h(Component, Object.assign(Object.assign({}, context.data), {
        class: [context.props.className, context.data.class].filter(e => e).join(' '),
        props: Object.assign(Object.assign(Object.assign(Object.assign({}, rest), additionalProps), context.props), {
          className: [context.props.className, context.data.class].filter(e => e).join(' '),
          styles: _styles
        })
      }), context.children);
    }

  }); // styledComponent.prototype.BaseComponent = Component

  return styledComponent;
}

export { styled };
