import { MAX_COLOR_ALPHA } from './consts.js';
import { rgb2hsv } from './rgb2hsv.js';
import { rgb2hex } from './rgb2hex.js';
import { _rgbaOrHexString } from './_rgbaOrHexString.js';

/** Converts an RGBA color to a color object (alpha defaults to 100). */

function getColorFromRGBA(rgba) {
  const {
    a = MAX_COLOR_ALPHA,
    b,
    g,
    r
  } = rgba;
  const {
    h,
    s,
    v
  } = rgb2hsv(r, g, b);
  const hex = rgb2hex(r, g, b);

  const str = _rgbaOrHexString(r, g, b, a, hex);

  return {
    a,
    b,
    g,
    h,
    hex,
    r,
    s,
    str,
    v
  };
}

export { getColorFromRGBA };
